/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Contents of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.416 - (hide annotations) (download)
Sun Mar 31 02:17:12 2013 UTC (18 months, 3 weeks ago) by vapier
Branch: MAIN
Changes since 1.415: +15 -1 lines
epatch: add support for users to exclude specific patches via EPATCH_USER_EXCLUDE #439402

1 mgorny 1.410 # Copyright 1999-2013 Gentoo Foundation
2 azarah 1.1 # Distributed under the terms of the GNU General Public License v2
3 vapier 1.416 # $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.415 2013/03/12 14:16:15 vapier Exp $
4 vapier 1.283
5     # @ECLASS: eutils.eclass
6     # @MAINTAINER:
7     # base-system@gentoo.org
8     # @BLURB: many extra (but common) functions that are used in ebuilds
9     # @DESCRIPTION:
10     # The eutils eclass contains a suite of functions that complement
11     # the ones that ebuild.sh already contain. The idea is that the functions
12     # are not required in all ebuilds but enough utilize them to have a common
13     # home rather than having multiple ebuilds implementing the same thing.
14 swegener 1.286 #
15 vapier 1.283 # Due to the nature of this eclass, some functions may have maintainers
16     # different from the overall eclass!
17 azarah 1.1
18 vapier 1.371 if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19     ___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20    
21 mgorny 1.395 inherit multilib toolchain-funcs user
22 azarah 1.1
23 betelgeuse 1.329 if has "${EAPI:-0}" 0 1 2; then
24    
25 vapier 1.283 # @FUNCTION: epause
26     # @USAGE: [seconds]
27     # @DESCRIPTION:
28     # Sleep for the specified number of seconds (default of 5 seconds). Useful when
29     # printing a message the user should probably be reading and often used in
30     # conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31 betelgeuse 1.329 # don't wait at all. Defined in EAPIs 0 1 and 2.
32 ciaranm 1.98 epause() {
33 vapier 1.245 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34 ciaranm 1.98 }
35    
36 vapier 1.283 # @FUNCTION: ebeep
37     # @USAGE: [number of beeps]
38     # @DESCRIPTION:
39     # Issue the specified number of beeps (default of 5 beeps). Useful when
40     # printing a message the user should probably be reading and often used in
41     # conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42 betelgeuse 1.329 # don't beep at all. Defined in EAPIs 0 1 and 2.
43 ciaranm 1.98 ebeep() {
44     local n
45 vapier 1.245 if [[ -z ${EBEEP_IGNORE} ]] ; then
46 ciaranm 1.98 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47     echo -ne "\a"
48     sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49     echo -ne "\a"
50     sleep 1
51     done
52     fi
53     }
54    
55 reavertm 1.331 else
56    
57 reavertm 1.332 ebeep() {
58 reavertm 1.337 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59 reavertm 1.332 }
60 reavertm 1.331
61 reavertm 1.332 epause() {
62 reavertm 1.337 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63 reavertm 1.332 }
64 reavertm 1.331
65 betelgeuse 1.329 fi
66    
67 betelgeuse 1.348 # @FUNCTION: eqawarn
68     # @USAGE: [message]
69     # @DESCRIPTION:
70 mgorny 1.363 # Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71     # implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72     # profile.
73 betelgeuse 1.348 if ! declare -F eqawarn >/dev/null ; then
74     eqawarn() {
75 mgorny 1.363 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 ferringb 1.370 :
77 betelgeuse 1.348 }
78     fi
79    
80 hollow 1.298 # @FUNCTION: ecvs_clean
81 vapier 1.299 # @USAGE: [list of dirs]
82 hollow 1.298 # @DESCRIPTION:
83 vapier 1.299 # Remove CVS directories recursiveley. Useful when a source tarball contains
84     # internal CVS directories. Defaults to $PWD.
85 hollow 1.298 ecvs_clean() {
86 vapier 1.299 [[ -z $* ]] && set -- .
87 hollow 1.298 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88     find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89     }
90    
91     # @FUNCTION: esvn_clean
92 vapier 1.299 # @USAGE: [list of dirs]
93 hollow 1.298 # @DESCRIPTION:
94 vapier 1.299 # Remove .svn directories recursiveley. Useful when a source tarball contains
95     # internal Subversion directories. Defaults to $PWD.
96 hollow 1.298 esvn_clean() {
97 vapier 1.299 [[ -z $* ]] && set -- .
98 hollow 1.298 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99     }
100    
101 vapier 1.373 # @FUNCTION: estack_push
102     # @USAGE: <stack> [items to push]
103     # @DESCRIPTION:
104     # Push any number of items onto the specified stack. Pick a name that
105     # is a valid variable (i.e. stick to alphanumerics), and push as many
106     # items as you like onto the stack at once.
107     #
108     # The following code snippet will echo 5, then 4, then 3, then ...
109     # @CODE
110     # estack_push mystack 1 2 3 4 5
111     # while estack_pop mystack i ; do
112     # echo "${i}"
113     # done
114     # @CODE
115     estack_push() {
116     [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117     local stack_name="__ESTACK_$1__" ; shift
118     eval ${stack_name}+=\( \"\$@\" \)
119     }
120    
121     # @FUNCTION: estack_pop
122     # @USAGE: <stack> [variable]
123     # @DESCRIPTION:
124     # Pop a single item off the specified stack. If a variable is specified,
125     # the popped item is stored there. If no more items are available, return
126     # 1, else return 0. See estack_push for more info.
127     estack_pop() {
128     [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129    
130     # We use the fugly __estack_xxx var names to avoid collision with
131     # passing back the return value. If we used "local i" and the
132     # caller ran `estack_pop ... i`, we'd end up setting the local
133     # copy of "i" rather than the caller's copy. The __estack_xxx
134     # garbage is preferable to using $1/$2 everywhere as that is a
135     # bit harder to read.
136     local __estack_name="__ESTACK_$1__" ; shift
137     local __estack_retvar=$1 ; shift
138 vapier 1.376 eval local __estack_i=\${#${__estack_name}\[@\]}
139 vapier 1.373 # Don't warn -- let the caller interpret this as a failure
140     # or as normal behavior (akin to `shift`)
141     [[ $(( --__estack_i )) -eq -1 ]] && return 1
142    
143     if [[ -n ${__estack_retvar} ]] ; then
144 vapier 1.376 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 vapier 1.373 fi
146 vapier 1.376 eval unset ${__estack_name}\[${__estack_i}\]
147 vapier 1.373 }
148    
149 vapier 1.322 # @FUNCTION: eshopts_push
150 vapier 1.330 # @USAGE: [options to `set` or `shopt`]
151 vapier 1.322 # @DESCRIPTION:
152     # Often times code will want to enable a shell option to change code behavior.
153     # Since changing shell options can easily break other pieces of code (which
154     # assume the default state), eshopts_push is used to (1) push the current shell
155     # options onto a stack and (2) pass the specified arguments to set.
156     #
157 vapier 1.330 # If the first argument is '-s' or '-u', we assume you want to call `shopt`
158     # rather than `set` as there are some options only available via that.
159     #
160 vapier 1.322 # A common example is to disable shell globbing so that special meaning/care
161     # may be used with variables/arguments to custom functions. That would be:
162     # @CODE
163 vapier 1.376 # eshopts_push -s noglob
164 vapier 1.322 # for x in ${foo} ; do
165     # if ...some check... ; then
166     # eshopts_pop
167     # return 0
168     # fi
169     # done
170     # eshopts_pop
171     # @CODE
172     eshopts_push() {
173 vapier 1.330 if [[ $1 == -[su] ]] ; then
174 vapier 1.376 estack_push eshopts "$(shopt -p)"
175 vapier 1.330 [[ $# -eq 0 ]] && return 0
176 vapier 1.375 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 vapier 1.330 else
178 vapier 1.376 estack_push eshopts $-
179 vapier 1.330 [[ $# -eq 0 ]] && return 0
180 vapier 1.375 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 vapier 1.330 fi
182 vapier 1.322 }
183    
184     # @FUNCTION: eshopts_pop
185     # @USAGE:
186     # @DESCRIPTION:
187     # Restore the shell options to the state saved with the corresponding
188     # eshopts_push call. See that function for more details.
189     eshopts_pop() {
190 vapier 1.376 local s
191     estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 vapier 1.330 if [[ ${s} == "shopt -"* ]] ; then
193 vapier 1.375 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 vapier 1.330 else
195 vapier 1.375 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196     set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 vapier 1.330 fi
198 vapier 1.322 }
199    
200 vapier 1.373 # @FUNCTION: eumask_push
201     # @USAGE: <new umask>
202     # @DESCRIPTION:
203     # Set the umask to the new value specified while saving the previous
204     # value onto a stack. Useful for temporarily changing the umask.
205     eumask_push() {
206     estack_push eumask "$(umask)"
207     umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208     }
209    
210     # @FUNCTION: eumask_pop
211     # @USAGE:
212     # @DESCRIPTION:
213     # Restore the previous umask state.
214     eumask_pop() {
215 vapier 1.382 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 vapier 1.373 local s
217     estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218     umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219     }
220    
221 vapier 1.325 # @VARIABLE: EPATCH_SOURCE
222     # @DESCRIPTION:
223     # Default directory to search for patches.
224 azarah 1.2 EPATCH_SOURCE="${WORKDIR}/patch"
225 vapier 1.325 # @VARIABLE: EPATCH_SUFFIX
226     # @DESCRIPTION:
227     # Default extension for patches (do not prefix the period yourself).
228 azarah 1.2 EPATCH_SUFFIX="patch.bz2"
229 vapier 1.325 # @VARIABLE: EPATCH_OPTS
230     # @DESCRIPTION:
231 vapier 1.391 # Options to pass to patch. Meant for ebuild/package-specific tweaking
232     # such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233     # for single patch tweaking, you can also pass flags directly to epatch.
234     EPATCH_OPTS=""
235     # @VARIABLE: EPATCH_COMMON_OPTS
236     # @DESCRIPTION:
237     # Common options to pass to `patch`. You probably should never need to
238     # change these. If you do, please discuss it with base-system first to
239     # be sure.
240 vapier 1.325 # @CODE
241     # -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
242     # --no-backup-if-mismatch - do not leave .orig files behind
243     # -E - automatically remove empty files
244     # @CODE
245 vapier 1.391 EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246 vapier 1.325 # @VARIABLE: EPATCH_EXCLUDE
247     # @DESCRIPTION:
248 mr_bones_ 1.308 # List of patches not to apply. Note this is only file names,
249 vapier 1.325 # and not the full path. Globs accepted.
250 azarah 1.6 EPATCH_EXCLUDE=""
251 vapier 1.325 # @VARIABLE: EPATCH_SINGLE_MSG
252     # @DESCRIPTION:
253 azarah 1.9 # Change the printed message for a single patch.
254     EPATCH_SINGLE_MSG=""
255 vapier 1.325 # @VARIABLE: EPATCH_MULTI_MSG
256     # @DESCRIPTION:
257 vapier 1.173 # Change the printed message for multiple patches.
258     EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
259 vapier 1.325 # @VARIABLE: EPATCH_FORCE
260     # @DESCRIPTION:
261     # Only require patches to match EPATCH_SUFFIX rather than the extended
262     # arch naming style.
263 azarah 1.29 EPATCH_FORCE="no"
264 vapier 1.416 # @VARIABLE: EPATCH_USER_EXCLUDE
265     # @DEFAULT_UNSET
266     # @DESCRIPTION:
267     # List of patches not to apply. Note this is only file names,
268     # and not the full path. Globs accepted.
269 azarah 1.2
270 vapier 1.325 # @FUNCTION: epatch
271 vapier 1.391 # @USAGE: [options] [patches] [dirs of patches]
272 vapier 1.325 # @DESCRIPTION:
273     # epatch is designed to greatly simplify the application of patches. It can
274     # process patch files directly, or directories of patches. The patches may be
275     # compressed (bzip/gzip/etc...) or plain text. You generally need not specify
276     # the -p option as epatch will automatically attempt -p0 to -p5 until things
277     # apply successfully.
278 azarah 1.2 #
279 vapier 1.391 # If you do not specify any patches/dirs, then epatch will default to the
280     # directory specified by EPATCH_SOURCE.
281     #
282     # Any options specified that start with a dash will be passed down to patch
283     # for this specific invocation. As soon as an arg w/out a dash is found, then
284     # arg processing stops.
285 azarah 1.2 #
286 vapier 1.325 # When processing directories, epatch will apply all patches that match:
287     # @CODE
288 vapier 1.350 # if ${EPATCH_FORCE} != "yes"
289 vapier 1.325 # ??_${ARCH}_foo.${EPATCH_SUFFIX}
290     # else
291     # *.${EPATCH_SUFFIX}
292     # @CODE
293     # The leading ?? are typically numbers used to force consistent patch ordering.
294     # The arch field is used to apply patches only for the host architecture with
295     # the special value of "all" means apply for everyone. Note that using values
296     # other than "all" is highly discouraged -- you should apply patches all the
297     # time and let architecture details be detected at configure/compile time.
298 azarah 1.2 #
299 vapier 1.325 # If EPATCH_SUFFIX is empty, then no period before it is implied when searching
300     # for patches to apply.
301 azarah 1.2 #
302 vapier 1.325 # Refer to the other EPATCH_xxx variables for more customization of behavior.
303 azarah 1.2 epatch() {
304 swegener 1.231 _epatch_draw_line() {
305 vapier 1.325 # create a line of same length as input string
306 agriffis 1.229 [[ -z $1 ]] && set "$(printf "%65s" '')"
307     echo "${1//?/=}"
308 vapier 1.219 }
309 azarah 1.3
310 vapier 1.195 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
311    
312 vapier 1.391 # First process options. We localize the EPATCH_OPTS setting
313     # from above so that we can pass it on in the loop below with
314     # any additional values the user has specified.
315     local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
316     while [[ $# -gt 0 ]] ; do
317     case $1 in
318     -*) EPATCH_OPTS+=( "$1" ) ;;
319     *) break ;;
320     esac
321     shift
322     done
323    
324 vapier 1.325 # Let the rest of the code process one user arg at a time --
325     # each arg may expand into multiple patches, and each arg may
326     # need to start off with the default global EPATCH_xxx values
327     if [[ $# -gt 1 ]] ; then
328     local m
329 vapier 1.94 for m in "$@" ; do
330     epatch "${m}"
331     done
332     return 0
333 azarah 1.3 fi
334    
335 vapier 1.325 local SINGLE_PATCH="no"
336     # no args means process ${EPATCH_SOURCE}
337     [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
338    
339     if [[ -f $1 ]] ; then
340 azarah 1.3 SINGLE_PATCH="yes"
341 vapier 1.325 set -- "$1"
342     # Use the suffix from the single patch (localize it); the code
343     # below will find the suffix for us
344     local EPATCH_SUFFIX=$1
345    
346     elif [[ -d $1 ]] ; then
347     # Some people like to make dirs of patches w/out suffixes (vim)
348     set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
349 danarmak 1.32
350 vapier 1.359 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
351     # Re-use EPATCH_SOURCE as a search dir
352     epatch "${EPATCH_SOURCE}/$1"
353     return $?
354    
355 azarah 1.3 else
356 vapier 1.325 # sanity check ... if it isn't a dir or file, wtf man ?
357     [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
358     echo
359     eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
360     eerror
361     eerror " ${EPATCH_SOURCE}"
362     eerror " ( ${EPATCH_SOURCE##*/} )"
363     echo
364     die "Cannot find \$EPATCH_SOURCE!"
365 azarah 1.3 fi
366 azarah 1.2
367 vapier 1.391 # Now that we know we're actually going to apply something, merge
368     # all of the patch options back in to a single variable for below.
369     EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
370    
371 vapier 1.325 local PIPE_CMD
372 azarah 1.2 case ${EPATCH_SUFFIX##*\.} in
373 vapier 1.325 xz) PIPE_CMD="xz -dc" ;;
374     lzma) PIPE_CMD="lzma -dc" ;;
375     bz2) PIPE_CMD="bzip2 -dc" ;;
376     gz|Z|z) PIPE_CMD="gzip -dc" ;;
377     ZIP|zip) PIPE_CMD="unzip -p" ;;
378     *) ;;
379 azarah 1.2 esac
380    
381 vapier 1.325 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
382    
383     local x
384     for x in "$@" ; do
385     # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
386     # didn't match anything, ignore continue on
387     [[ ! -f ${x} ]] && continue
388    
389     local patchname=${x##*/}
390    
391     # Apply single patches, or forced sets of patches, or
392     # patches with ARCH dependant names.
393 flameeyes 1.266 # ???_arch_foo.patch
394 vapier 1.325 # Else, skip this input altogether
395     local a=${patchname#*_} # strip the ???_
396     a=${a%%_*} # strip the _foo.patch
397     if ! [[ ${SINGLE_PATCH} == "yes" || \
398 ulm 1.354 ${EPATCH_FORCE} == "yes" || \
399     ${a} == all || \
400     ${a} == ${ARCH} ]]
401 azarah 1.2 then
402 vapier 1.325 continue
403     fi
404 azarah 1.6
405 vapier 1.325 # Let people filter things dynamically
406     if [[ -n ${EPATCH_EXCLUDE} ]] ; then
407     # let people use globs in the exclude
408     eshopts_push -o noglob
409    
410 scarabeus 1.328 local ex
411 vapier 1.325 for ex in ${EPATCH_EXCLUDE} ; do
412 scarabeus 1.328 if [[ ${patchname} == ${ex} ]] ; then
413 vapier 1.416 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
414     eshopts_pop
415     continue 2
416     fi
417     done
418    
419     for ex in ${EPATCH_USER_EXCLUDE} ; do
420     if [[ ${patchname} == ${ex} ]] ; then
421     einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
422 scarabeus 1.328 eshopts_pop
423     continue 2
424     fi
425 vapier 1.325 done
426 vapier 1.326
427 vapier 1.325 eshopts_pop
428     fi
429 danarmak 1.32
430 vapier 1.325 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
431     if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
432     einfo "${EPATCH_SINGLE_MSG}"
433 azarah 1.3 else
434 vapier 1.325 einfo "Applying ${patchname} ..."
435 azarah 1.3 fi
436 vapier 1.325 else
437     einfo " ${patchname} ..."
438     fi
439 azarah 1.2
440 vapier 1.325 # most of the time, there will only be one run per unique name,
441     # but if there are more, make sure we get unique log filenames
442     local STDERR_TARGET="${T}/${patchname}.out"
443     if [[ -e ${STDERR_TARGET} ]] ; then
444     STDERR_TARGET="${T}/${patchname}-$$.out"
445     fi
446 azarah 1.2
447 vapier 1.369 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
448 vapier 1.304
449 vapier 1.325 # Decompress the patch if need be
450     local count=0
451     local PATCH_TARGET
452     if [[ -n ${PIPE_CMD} ]] ; then
453     PATCH_TARGET="${T}/$$.patch"
454     echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
455 vapier 1.304
456 vapier 1.325 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
457     echo
458     eerror "Could not extract patch!"
459     #die "Could not extract patch!"
460     count=5
461     break
462 vapier 1.305 fi
463 vapier 1.325 else
464     PATCH_TARGET=${x}
465     fi
466 vapier 1.305
467 vapier 1.325 # Check for absolute paths in patches. If sandbox is disabled,
468     # people could (accidently) patch files in the root filesystem.
469     # Or trigger other unpleasantries #237667. So disallow -p0 on
470     # such patches.
471     local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
472     if [[ -n ${abs_paths} ]] ; then
473     count=1
474     printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
475     fi
476 vapier 1.353 # Similar reason, but with relative paths.
477     local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
478     if [[ -n ${rel_paths} ]] ; then
479     eqawarn "QA Notice: Your patch uses relative paths '../'."
480     eqawarn " In the future this will cause a failure."
481     eqawarn "${rel_paths}"
482     fi
483 vapier 1.325
484     # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
485 vapier 1.383 local patch_cmd
486 vapier 1.325 while [[ ${count} -lt 5 ]] ; do
487 naota 1.386 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
488 vapier 1.383
489 vapier 1.325 # Generate some useful debug info ...
490     (
491     _epatch_draw_line "***** ${patchname} *****"
492     echo
493 vapier 1.383 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
494 vapier 1.325 echo
495     _epatch_draw_line "***** ${patchname} *****"
496 vapier 1.383 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
497 vapier 1.360 ret=$?
498     echo
499     echo "patch program exited with status ${ret}"
500     exit ${ret}
501 vapier 1.325 ) >> "${STDERR_TARGET}"
502 azarah 1.8
503 vapier 1.360 if [ $? -eq 0 ] ; then
504 vapier 1.325 (
505     _epatch_draw_line "***** ${patchname} *****"
506     echo
507     echo "ACTUALLY APPLYING ${patchname} ..."
508     echo
509     _epatch_draw_line "***** ${patchname} *****"
510 vapier 1.383 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
511 vapier 1.360 ret=$?
512     echo
513     echo "patch program exited with status ${ret}"
514     exit ${ret}
515 vapier 1.325 ) >> "${STDERR_TARGET}"
516 danarmak 1.32
517 vapier 1.325 if [ $? -ne 0 ] ; then
518     echo
519     eerror "A dry-run of patch command succeeded, but actually"
520     eerror "applying the patch failed!"
521     #die "Real world sux compared to the dreamworld!"
522     count=5
523 azarah 1.2 fi
524 vapier 1.325 break
525 azarah 1.8 fi
526    
527 vapier 1.325 : $(( count++ ))
528     done
529 azarah 1.8
530 vapier 1.325 # if we had to decompress the patch, delete the temp one
531     if [[ -n ${PIPE_CMD} ]] ; then
532     rm -f "${PATCH_TARGET}"
533     fi
534 azarah 1.3
535 vapier 1.325 if [[ ${count} -ge 5 ]] ; then
536     echo
537     eerror "Failed Patch: ${patchname} !"
538     eerror " ( ${PATCH_TARGET} )"
539     eerror
540     eerror "Include in your bugreport the contents of:"
541     eerror
542     eerror " ${STDERR_TARGET}"
543     echo
544     die "Failed Patch: ${patchname}!"
545 azarah 1.2 fi
546 vapier 1.325
547 vapier 1.383 # if everything worked, delete the full debug patch log
548 vapier 1.325 rm -f "${STDERR_TARGET}"
549 vapier 1.383
550     # then log away the exact stuff for people to review later
551     cat <<-EOF >> "${T}/epatch.log"
552     PATCH: ${x}
553     CMD: ${patch_cmd}
554     PWD: ${PWD}
555    
556     EOF
557 vapier 1.325 eend 0
558 azarah 1.2 done
559 vapier 1.325
560     [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
561     : # everything worked
562 azarah 1.26 }
563 vapier 1.361
564     # @FUNCTION: epatch_user
565     # @USAGE:
566     # @DESCRIPTION:
567     # Applies user-provided patches to the source tree. The patches are
568 vapier 1.406 # taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
569 vapier 1.361 # of these three directories to exist will be the one to use, ignoring
570 vapier 1.387 # any more general directories which might exist as well. They must end
571     # in ".patch" to be applied.
572 vapier 1.361 #
573     # User patches are intended for quick testing of patches without ebuild
574     # modifications, as well as for permanent customizations a user might
575     # desire. Obviously, there can be no official support for arbitrarily
576     # patched ebuilds. So whenever a build log in a bug report mentions that
577     # user patches were applied, the user should be asked to reproduce the
578     # problem without these.
579     #
580     # Not all ebuilds do call this function, so placing patches in the
581     # stated directory might or might not work, depending on the package and
582     # the eclasses it inherits and uses. It is safe to call the function
583     # repeatedly, so it is always possible to add a call at the ebuild
584     # level. The first call is the time when the patches will be
585     # applied.
586     #
587     # Ideally, this function should be called after gentoo-specific patches
588     # have been applied, so that their code can be modified as well, but
589     # before calls to e.g. eautoreconf, as the user patches might affect
590     # autotool input files as well.
591 vapier 1.318 epatch_user() {
592     [[ $# -ne 0 ]] && die "epatch_user takes no options"
593    
594 vapier 1.361 # Allow multiple calls to this function; ignore all but the first
595 vapier 1.383 local applied="${T}/epatch_user.log"
596 vapier 1.361 [[ -e ${applied} ]] && return 2
597    
598 vapier 1.318 # don't clobber any EPATCH vars that the parent might want
599 zmedico 1.323 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
600 vapier 1.406 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
601 vapier 1.318 EPATCH_SOURCE=${base}/${CTARGET}/${check}
602     [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
603     [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
604     if [[ -d ${EPATCH_SOURCE} ]] ; then
605     EPATCH_SOURCE=${EPATCH_SOURCE} \
606     EPATCH_SUFFIX="patch" \
607     EPATCH_FORCE="yes" \
608     EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
609     epatch
610 vapier 1.361 echo "${EPATCH_SOURCE}" > "${applied}"
611 vapier 1.349 return 0
612 vapier 1.318 fi
613     done
614 vapier 1.361 echo "none" > "${applied}"
615 vapier 1.349 return 1
616 vapier 1.318 }
617 azarah 1.26
618 vapier 1.283 # @FUNCTION: emktemp
619     # @USAGE: [temp dir]
620     # @DESCRIPTION:
621 vapier 1.52 # Cheap replacement for when debianutils (and thus mktemp)
622 vapier 1.283 # does not exist on the users system.
623 vapier 1.117 emktemp() {
624 vapier 1.119 local exe="touch"
625 vapier 1.194 [[ $1 == -d ]] && exe="mkdir" && shift
626     local topdir=$1
627 mr_bones_ 1.100
628 vapier 1.194 if [[ -z ${topdir} ]] ; then
629     [[ -z ${T} ]] \
630 vapier 1.117 && topdir="/tmp" \
631 vapier 1.194 || topdir=${T}
632 vapier 1.117 fi
633    
634 vapier 1.280 if ! type -P mktemp > /dev/null ; then
635     # system lacks `mktemp` so we have to fake it
636 vapier 1.117 local tmp=/
637 vapier 1.194 while [[ -e ${tmp} ]] ; do
638     tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
639 vapier 1.117 done
640 vapier 1.194 ${exe} "${tmp}" || ${exe} -p "${tmp}"
641 vapier 1.117 echo "${tmp}"
642 vapier 1.52 else
643 vapier 1.280 # the args here will give slightly wierd names on BSD,
644     # but should produce a usable file on all userlands
645 flameeyes 1.223 if [[ ${exe} == "touch" ]] ; then
646 vapier 1.280 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
647 flameeyes 1.223 else
648 vapier 1.280 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
649 flameeyes 1.223 fi
650 vapier 1.52 fi
651     }
652    
653 vapier 1.283 # @FUNCTION: edos2unix
654     # @USAGE: <file> [more files ...]
655     # @DESCRIPTION:
656     # A handy replacement for dos2unix, recode, fixdos, etc... This allows you
657     # to remove all of these text utilities from DEPEND variables because this
658     # is a script based solution. Just give it a list of files to convert and
659     # they will all be changed from the DOS CRLF format to the UNIX LF format.
660 vapier 1.24 edos2unix() {
661 vapier 1.366 [[ $# -eq 0 ]] && return 0
662     sed -i 's/\r$//' -- "$@" || die
663 vapier 1.39 }
664    
665 jlec 1.377 # @FUNCTION: make_desktop_entry
666     # @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
667     # @DESCRIPTION:
668     # Make a .desktop file.
669     #
670     # @CODE
671     # binary: what command does the app run with ?
672     # name: the name that will show up in the menu
673 vapier 1.401 # icon: the icon to use in the menu entry
674 jlec 1.377 # this can be relative (to /usr/share/pixmaps) or
675     # a full path to an icon
676     # type: what kind of application is this?
677     # for categories:
678     # http://standards.freedesktop.org/menu-spec/latest/apa.html
679     # if unset, function tries to guess from package's category
680 vapier 1.341 # fields: extra fields to append to the desktop file; a printf string
681 jlec 1.377 # @CODE
682 vapier 1.39 make_desktop_entry() {
683 vapier 1.341 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
684 vapier 1.39
685 vapier 1.158 local exec=${1}
686     local name=${2:-${PN}}
687 wolf31o2 1.293 local icon=${3:-${PN}}
688 vapier 1.158 local type=${4}
689 vapier 1.341 local fields=${5}
690 vapier 1.158
691     if [[ -z ${type} ]] ; then
692     local catmaj=${CATEGORY%%-*}
693     local catmin=${CATEGORY##*-}
694     case ${catmaj} in
695     app)
696     case ${catmin} in
697 pacho 1.384 accessibility) type="Utility;Accessibility";;
698 vapier 1.338 admin) type=System;;
699     antivirus) type=System;;
700 pacho 1.384 arch) type="Utility;Archiving";;
701     backup) type="Utility;Archiving";;
702     cdr) type="AudioVideo;DiscBurning";;
703     dicts) type="Office;Dictionary";;
704 vapier 1.338 doc) type=Documentation;;
705 pacho 1.384 editors) type="Utility;TextEditor";;
706     emacs) type="Development;TextEditor";;
707     emulation) type="System;Emulator";;
708     laptop) type="Settings;HardwareSettings";;
709 vapier 1.338 office) type=Office;;
710 pacho 1.384 pda) type="Office;PDA";;
711     vim) type="Development;TextEditor";;
712     xemacs) type="Development;TextEditor";;
713 vapier 1.158 esac
714 azarah 1.59 ;;
715 vapier 1.158
716     dev)
717 vapier 1.159 type="Development"
718 vapier 1.158 ;;
719    
720     games)
721     case ${catmin} in
722 wolf31o2 1.265 action|fps) type=ActionGame;;
723 vapier 1.338 arcade) type=ArcadeGame;;
724     board) type=BoardGame;;
725     emulation) type=Emulator;;
726     kids) type=KidsGame;;
727     puzzle) type=LogicGame;;
728     roguelike) type=RolePlaying;;
729     rpg) type=RolePlaying;;
730 vapier 1.158 simulation) type=Simulation;;
731 vapier 1.338 sports) type=SportsGame;;
732     strategy) type=StrategyGame;;
733 vapier 1.158 esac
734 vapier 1.159 type="Game;${type}"
735 vapier 1.158 ;;
736    
737 vapier 1.284 gnome)
738     type="Gnome;GTK"
739     ;;
740    
741     kde)
742     type="KDE;Qt"
743     ;;
744    
745 vapier 1.158 mail)
746 vapier 1.159 type="Network;Email"
747 vapier 1.158 ;;
748    
749     media)
750     case ${catmin} in
751 vapier 1.339 gfx)
752     type=Graphics
753     ;;
754     *)
755     case ${catmin} in
756     radio) type=Tuner;;
757     sound) type=Audio;;
758     tv) type=TV;;
759     video) type=Video;;
760     esac
761     type="AudioVideo;${type}"
762     ;;
763 vapier 1.158 esac
764 wolf31o2 1.65 ;;
765 vapier 1.158
766     net)
767     case ${catmin} in
768     dialup) type=Dialup;;
769 vapier 1.338 ftp) type=FileTransfer;;
770     im) type=InstantMessaging;;
771     irc) type=IRCClient;;
772     mail) type=Email;;
773     news) type=News;;
774     nntp) type=News;;
775     p2p) type=FileTransfer;;
776     voip) type=Telephony;;
777 vapier 1.158 esac
778 vapier 1.159 type="Network;${type}"
779 vapier 1.158 ;;
780    
781     sci)
782     case ${catmin} in
783 vapier 1.284 astro*) type=Astronomy;;
784 vapier 1.338 bio*) type=Biology;;
785     calc*) type=Calculator;;
786     chem*) type=Chemistry;;
787 vapier 1.284 elec*) type=Electronics;;
788 vapier 1.338 geo*) type=Geology;;
789     math*) type=Math;;
790 vapier 1.284 physics) type=Physics;;
791     visual*) type=DataVisualization;;
792 vapier 1.159 esac
793 abcd 1.336 type="Education;Science;${type}"
794 vapier 1.158 ;;
795    
796 vapier 1.284 sys)
797     type="System"
798     ;;
799    
800 vapier 1.158 www)
801     case ${catmin} in
802     client) type=WebBrowser;;
803     esac
804 abcd 1.336 type="Network;${type}"
805 azarah 1.59 ;;
806 vapier 1.158
807 azarah 1.59 *)
808     type=
809     ;;
810 vapier 1.39 esac
811     fi
812 carlo 1.177 if [ "${SLOT}" == "0" ] ; then
813     local desktop_name="${PN}"
814     else
815     local desktop_name="${PN}-${SLOT}"
816     fi
817 vapier 1.272 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
818 vapier 1.271 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
819 vapier 1.39
820 abcd 1.336 # Don't append another ";" when a valid category value is provided.
821     type=${type%;}${type:+;}
822    
823     eshopts_push -s extglob
824     if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
825     ewarn "As described in the Icon Theme Specification, icon file extensions are not"
826     ewarn "allowed in .desktop files if the value is not an absolute path."
827     icon=${icon%.@(xpm|png|svg)}
828     fi
829     eshopts_pop
830    
831 vapier 1.271 cat <<-EOF > "${desktop}"
832     [Desktop Entry]
833     Name=${name}
834     Type=Application
835     Comment=${DESCRIPTION}
836     Exec=${exec}
837     TryExec=${exec%% *}
838     Icon=${icon}
839 abcd 1.336 Categories=${type}
840 vapier 1.271 EOF
841 vapier 1.39
842 vapier 1.341 if [[ ${fields:-=} != *=* ]] ; then
843     # 5th arg used to be value to Path=
844     ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
845     fields="Path=${fields}"
846     fi
847 vapier 1.342 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
848 wolf31o2 1.293
849 vapier 1.204 (
850     # wrap the env here so that the 'insinto' call
851     # doesn't corrupt the env of the caller
852     insinto /usr/share/applications
853     doins "${desktop}"
854 vapier 1.340 ) || die "installing desktop file failed"
855 danarmak 1.32 }
856    
857 vapier 1.283 # @FUNCTION: validate_desktop_entries
858     # @USAGE: [directories]
859     # @MAINTAINER:
860     # Carsten Lohrke <carlo@gentoo.org>
861     # @DESCRIPTION:
862 carlo 1.278 # Validate desktop entries using desktop-file-utils
863 carlo 1.277 validate_desktop_entries() {
864     if [[ -x /usr/bin/desktop-file-validate ]] ; then
865     einfo "Checking desktop entry validity"
866     local directories=""
867 carlo 1.279 for d in /usr/share/applications $@ ; do
868     [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
869 carlo 1.277 done
870 carlo 1.279 if [[ -n ${directories} ]] ; then
871     for FILE in $(find ${directories} -name "*\.desktop" \
872     -not -path '*.hidden*' | sort -u 2>/dev/null)
873     do
874     local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
875     sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
876     [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
877     done
878     fi
879 carlo 1.277 echo ""
880     else
881     einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
882     fi
883     }
884    
885 vapier 1.283 # @FUNCTION: make_session_desktop
886 vapier 1.314 # @USAGE: <title> <command> [command args...]
887 vapier 1.283 # @DESCRIPTION:
888     # Make a GDM/KDM Session file. The title is the file to execute to start the
889     # Window Manager. The command is the name of the Window Manager.
890 vapier 1.314 #
891     # You can set the name of the file via the ${wm} variable.
892 lanius 1.133 make_session_desktop() {
893 vapier 1.314 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
894     [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
895 lanius 1.133
896 vapier 1.167 local title=$1
897     local command=$2
898 vapier 1.314 local desktop=${T}/${wm:-${PN}}.desktop
899     shift 2
900 lanius 1.133
901 vapier 1.271 cat <<-EOF > "${desktop}"
902     [Desktop Entry]
903     Name=${title}
904     Comment=This session logs you into ${title}
905 vapier 1.314 Exec=${command} $*
906 vapier 1.271 TryExec=${command}
907 vapier 1.314 Type=XSession
908 vapier 1.271 EOF
909 lanius 1.133
910 vapier 1.271 (
911     # wrap the env here so that the 'insinto' call
912     # doesn't corrupt the env of the caller
913 lanius 1.133 insinto /usr/share/xsessions
914     doins "${desktop}"
915 vapier 1.271 )
916 lanius 1.133 }
917    
918 vapier 1.283 # @FUNCTION: domenu
919     # @USAGE: <menus>
920     # @DESCRIPTION:
921     # Install the list of .desktop menu files into the appropriate directory
922     # (/usr/share/applications).
923 lanius 1.133 domenu() {
924 vapier 1.271 (
925     # wrap the env here so that the 'insinto' call
926     # doesn't corrupt the env of the caller
927     local i j ret=0
928 lanius 1.133 insinto /usr/share/applications
929 vapier 1.167 for i in "$@" ; do
930     if [[ -f ${i} ]] ; then
931     doins "${i}"
932 vapier 1.271 ((ret+=$?))
933 vapier 1.167 elif [[ -d ${i} ]] ; then
934     for j in "${i}"/*.desktop ; do
935     doins "${j}"
936 vapier 1.271 ((ret+=$?))
937 lanius 1.133 done
938 vapier 1.285 else
939     ((++ret))
940 swegener 1.190 fi
941 lanius 1.133 done
942 vapier 1.271 exit ${ret}
943     )
944 lanius 1.133 }
945 vapier 1.283
946     # @FUNCTION: newmenu
947     # @USAGE: <menu> <newname>
948     # @DESCRIPTION:
949     # Like all other new* functions, install the specified menu as newname.
950 vapier 1.167 newmenu() {
951 vapier 1.271 (
952     # wrap the env here so that the 'insinto' call
953     # doesn't corrupt the env of the caller
954 vapier 1.167 insinto /usr/share/applications
955 vapier 1.271 newins "$@"
956     )
957 vapier 1.167 }
958 lanius 1.133
959 hasufell 1.394 # @FUNCTION: _iconins
960     # @INTERNAL
961 vapier 1.283 # @DESCRIPTION:
962 hasufell 1.394 # function for use in doicon and newicon
963     _iconins() {
964 vapier 1.271 (
965     # wrap the env here so that the 'insinto' call
966     # doesn't corrupt the env of the caller
967 hasufell 1.394 local funcname=$1; shift
968     local size dir
969     local context=apps
970     local theme=hicolor
971    
972     while [[ $# -gt 0 ]] ; do
973     case $1 in
974     -s|--size)
975     if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
976     size=${2%%x*}
977     else
978     size=${2}
979     fi
980     case ${size} in
981     16|22|24|32|36|48|64|72|96|128|192|256)
982     size=${size}x${size};;
983     scalable)
984     ;;
985     *)
986     eerror "${size} is an unsupported icon size!"
987     exit 1;;
988     esac
989     shift 2;;
990     -t|--theme)
991     theme=${2}
992     shift 2;;
993     -c|--context)
994     context=${2}
995     shift 2;;
996     *)
997     if [[ -z ${size} ]] ; then
998     insinto /usr/share/pixmaps
999     else
1000     insinto /usr/share/icons/${theme}/${size}/${context}
1001     fi
1002    
1003     if [[ ${funcname} == doicon ]] ; then
1004     if [[ -f $1 ]] ; then
1005     doins "${1}"
1006     elif [[ -d $1 ]] ; then
1007     shopt -s nullglob
1008     doins "${1}"/*.{png,svg}
1009     shopt -u nullglob
1010     else
1011     eerror "${1} is not a valid file/directory!"
1012     exit 1
1013     fi
1014     else
1015     break
1016     fi
1017     shift 1;;
1018     esac
1019 lanius 1.133 done
1020 hasufell 1.394 if [[ ${funcname} == newicon ]] ; then
1021     newins "$@"
1022     fi
1023     ) || die
1024     }
1025    
1026     # @FUNCTION: doicon
1027     # @USAGE: [options] <icons>
1028     # @DESCRIPTION:
1029     # Install icon into the icon directory /usr/share/icons or into
1030     # /usr/share/pixmaps if "--size" is not set.
1031     # This is useful in conjunction with creating desktop/menu files.
1032     #
1033     # @CODE
1034     # options:
1035     # -s, --size
1036     # !!! must specify to install into /usr/share/icons/... !!!
1037     # size of the icon, like 48 or 48x48
1038     # supported icon sizes are:
1039     # 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1040     # -c, --context
1041     # defaults to "apps"
1042     # -t, --theme
1043     # defaults to "hicolor"
1044     #
1045     # icons: list of icons
1046     #
1047 hasufell 1.398 # example 1: doicon foobar.png fuqbar.svg suckbar.png
1048 hasufell 1.394 # results in: insinto /usr/share/pixmaps
1049 hasufell 1.398 # doins foobar.png fuqbar.svg suckbar.png
1050 hasufell 1.394 #
1051 ssuominen 1.399 # example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1052 hasufell 1.394 # results in: insinto /usr/share/icons/hicolor/48x48/apps
1053 ssuominen 1.399 # doins foobar.png fuqbar.png blobbar.png
1054 hasufell 1.394 # @CODE
1055     doicon() {
1056     _iconins ${FUNCNAME} "$@"
1057 lanius 1.133 }
1058 vapier 1.283
1059     # @FUNCTION: newicon
1060 hasufell 1.394 # @USAGE: [options] <icon> <newname>
1061 vapier 1.283 # @DESCRIPTION:
1062 hasufell 1.394 # Like doicon, install the specified icon as newname.
1063     #
1064     # @CODE
1065     # example 1: newicon foobar.png NEWNAME.png
1066     # results in: insinto /usr/share/pixmaps
1067     # newins foobar.png NEWNAME.png
1068     #
1069     # example 2: newicon -s 48 foobar.png NEWNAME.png
1070     # results in: insinto /usr/share/icons/hicolor/48x48/apps
1071     # newins foobar.png NEWNAME.png
1072     # @CODE
1073 vapier 1.167 newicon() {
1074 hasufell 1.394 _iconins ${FUNCNAME} "$@"
1075 vapier 1.167 }
1076 lanius 1.133
1077 vapier 1.287 # @FUNCTION: strip-linguas
1078     # @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1079     # @DESCRIPTION:
1080 mr_bones_ 1.100 # Make sure that LINGUAS only contains languages that
1081 vapier 1.287 # a package can support. The first form allows you to
1082     # specify a list of LINGUAS. The -i builds a list of po
1083     # files found in all the directories and uses the
1084     # intersection of the lists. The -u builds a list of po
1085     # files found in all the directories and uses the union
1086     # of the lists.
1087 vapier 1.92 strip-linguas() {
1088 vapier 1.242 local ls newls nols
1089 vapier 1.154 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1090     local op=$1; shift
1091 vapier 1.315 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1092 vapier 1.92 local d f
1093     for d in "$@" ; do
1094 vapier 1.154 if [[ ${op} == "-u" ]] ; then
1095     newls=${ls}
1096 vapier 1.92 else
1097     newls=""
1098     fi
1099 vapier 1.315 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1100 vapier 1.154 if [[ ${op} == "-i" ]] ; then
1101 ssuominen 1.358 has ${f} ${ls} && newls="${newls} ${f}"
1102 vapier 1.92 else
1103 ssuominen 1.358 has ${f} ${ls} || newls="${newls} ${f}"
1104 vapier 1.92 fi
1105     done
1106 vapier 1.154 ls=${newls}
1107 vapier 1.92 done
1108     else
1109 vapier 1.236 ls="$@"
1110 vapier 1.92 fi
1111    
1112 vapier 1.242 nols=""
1113 vapier 1.92 newls=""
1114     for f in ${LINGUAS} ; do
1115 ssuominen 1.358 if has ${f} ${ls} ; then
1116 vapier 1.120 newls="${newls} ${f}"
1117 vapier 1.92 else
1118 vapier 1.242 nols="${nols} ${f}"
1119 vapier 1.92 fi
1120     done
1121 vapier 1.244 [[ -n ${nols} ]] \
1122 pacho 1.388 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1123 vapier 1.237 export LINGUAS=${newls:1}
1124 vapier 1.92 }
1125 iggy 1.110
1126 vapier 1.283 # @FUNCTION: preserve_old_lib
1127     # @USAGE: <libs to preserve> [more libs]
1128     # @DESCRIPTION:
1129     # These functions are useful when a lib in your package changes ABI SONAME.
1130     # An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1131 eradicator 1.111 # would break packages that link against it. Most people get around this
1132     # by using the portage SLOT mechanism, but that is not always a relevant
1133 vapier 1.283 # solution, so instead you can call this from pkg_preinst. See also the
1134     # preserve_old_lib_notify function.
1135 eradicator 1.111 preserve_old_lib() {
1136 vapier 1.268 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1137 vapier 1.267 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1138 vapier 1.276 die "Invalid preserve_old_lib() usage"
1139 vapier 1.267 fi
1140     [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1141    
1142 vapier 1.297 # let portage worry about it
1143     has preserve-libs ${FEATURES} && return 0
1144    
1145 vapier 1.267 local lib dir
1146     for lib in "$@" ; do
1147     [[ -e ${ROOT}/${lib} ]] || continue
1148     dir=${lib%/*}
1149     dodir ${dir} || die "dodir ${dir} failed"
1150     cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1151     touch "${D}"/${lib}
1152     done
1153 eradicator 1.111 }
1154    
1155 vapier 1.283 # @FUNCTION: preserve_old_lib_notify
1156     # @USAGE: <libs to notify> [more libs]
1157     # @DESCRIPTION:
1158     # Spit helpful messages about the libraries preserved by preserve_old_lib.
1159 eradicator 1.111 preserve_old_lib_notify() {
1160 vapier 1.268 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1161 vapier 1.267 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1162 vapier 1.276 die "Invalid preserve_old_lib_notify() usage"
1163 vapier 1.267 fi
1164    
1165 vapier 1.297 # let portage worry about it
1166     has preserve-libs ${FEATURES} && return 0
1167    
1168 vapier 1.267 local lib notice=0
1169     for lib in "$@" ; do
1170     [[ -e ${ROOT}/${lib} ]] || continue
1171     if [[ ${notice} -eq 0 ]] ; then
1172     notice=1
1173     ewarn "Old versions of installed libraries were detected on your system."
1174     ewarn "In order to avoid breaking packages that depend on these old libs,"
1175     ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1176     ewarn "in order to remove these old dependencies. If you do not have this"
1177     ewarn "helper program, simply emerge the 'gentoolkit' package."
1178     ewarn
1179     fi
1180 phajdan.jr 1.393 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1181 vapier 1.267 done
1182 eradicator 1.111 }
1183 vapier 1.125
1184 vapier 1.283 # @FUNCTION: built_with_use
1185     # @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1186     # @DESCRIPTION:
1187 betelgeuse 1.329 #
1188     # Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1189     #
1190 vapier 1.283 # A temporary hack until portage properly supports DEPENDing on USE
1191     # flags being enabled in packages. This will check to see if the specified
1192     # DEPEND atom was built with the specified list of USE flags. The
1193     # --missing option controls the behavior if called on a package that does
1194     # not actually support the defined USE flags (aka listed in IUSE).
1195     # The default is to abort (call die). The -a and -o flags control
1196     # the requirements of the USE flags. They correspond to "and" and "or"
1197     # logic. So the -a flag means all listed USE flags must be enabled
1198 opfer 1.302 # while the -o flag means at least one of the listed IUSE flags must be
1199 vapier 1.283 # enabled. The --hidden option is really for internal use only as it
1200     # means the USE flag we're checking is hidden expanded, so it won't be found
1201     # in IUSE like normal USE flags.
1202 swegener 1.286 #
1203 vapier 1.283 # Remember that this function isn't terribly intelligent so order of optional
1204     # flags matter.
1205 vapier 1.125 built_with_use() {
1206 vapier 1.275 local hidden="no"
1207     if [[ $1 == "--hidden" ]] ; then
1208     hidden="yes"
1209     shift
1210     fi
1211    
1212 vapier 1.269 local missing_action="die"
1213     if [[ $1 == "--missing" ]] ; then
1214     missing_action=$2
1215     shift ; shift
1216     case ${missing_action} in
1217     true|false|die) ;;
1218     *) die "unknown action '${missing_action}'";;
1219     esac
1220     fi
1221    
1222 vapier 1.130 local opt=$1
1223     [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1224    
1225     local PKG=$(best_version $1)
1226 vapier 1.247 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1227 vapier 1.130 shift
1228    
1229 vapier 1.213 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1230 vapier 1.249 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1231 vapier 1.213
1232 cardoe 1.273 # if the IUSE file doesn't exist, the read will error out, we need to handle
1233     # this gracefully
1234 vapier 1.275 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1235 cardoe 1.273 case ${missing_action} in
1236     true) return 0;;
1237     false) return 1;;
1238     die) die "Unable to determine what USE flags $PKG was built with";;
1239     esac
1240     fi
1241    
1242 vapier 1.275 if [[ ${hidden} == "no" ]] ; then
1243 zmedico 1.301 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1244 vapier 1.275 # Don't check USE_EXPAND #147237
1245     local expand
1246     for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1247     if [[ $1 == ${expand}_* ]] ; then
1248     expand=""
1249     break
1250     fi
1251     done
1252     if [[ -n ${expand} ]] ; then
1253 zmedico 1.301 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1254 vapier 1.275 case ${missing_action} in
1255     true) return 0;;
1256     false) return 1;;
1257     die) die "$PKG does not actually support the $1 USE flag!";;
1258     esac
1259     fi
1260 vapier 1.269 fi
1261 vapier 1.250 fi
1262 vapier 1.249
1263 vapier 1.125 local USE_BUILT=$(<${USEFILE})
1264 vapier 1.130 while [[ $# -gt 0 ]] ; do
1265     if [[ ${opt} = "-o" ]] ; then
1266     has $1 ${USE_BUILT} && return 0
1267     else
1268     has $1 ${USE_BUILT} || return 1
1269     fi
1270 vapier 1.125 shift
1271     done
1272 vapier 1.130 [[ ${opt} = "-a" ]]
1273 vapier 1.125 }
1274 vapier 1.126
1275 vapier 1.289 # @FUNCTION: epunt_cxx
1276 vapier 1.283 # @USAGE: [dir to scan]
1277     # @DESCRIPTION:
1278     # Many configure scripts wrongly bail when a C++ compiler could not be
1279     # detected. If dir is not specified, then it defaults to ${S}.
1280     #
1281     # http://bugs.gentoo.org/73450
1282 vapier 1.126 epunt_cxx() {
1283 vapier 1.127 local dir=$1
1284     [[ -z ${dir} ]] && dir=${S}
1285     ebegin "Removing useless C++ checks"
1286 vapier 1.415 local f p any_found
1287 mgorny 1.412 while IFS= read -r -d '' f; do
1288 vapier 1.415 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1289     if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1290     any_found=1
1291     break
1292     fi
1293     done
1294 mgorny 1.412 done < <(find "${dir}" -name configure -print0)
1295 mgorny 1.410
1296 vapier 1.415 if [[ -z ${any_found} ]]; then
1297     eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1298     fi
1299 vapier 1.127 eend 0
1300 vapier 1.126 }
1301 ka0ttic 1.143
1302 vapier 1.283 # @FUNCTION: make_wrapper
1303 wolf31o2 1.295 # @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1304 vapier 1.283 # @DESCRIPTION:
1305     # Create a shell wrapper script named wrapper in installpath
1306     # (defaults to the bindir) to execute target (default of wrapper) by
1307     # first optionally setting LD_LIBRARY_PATH to the colon-delimited
1308     # libpaths followed by optionally changing directory to chdir.
1309 wolf31o2 1.160 make_wrapper() {
1310 wolf31o2 1.164 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1311 wolf31o2 1.160 local tmpwrapper=$(emktemp)
1312 vapier 1.414
1313     (
1314     echo '#!/bin/sh'
1315     [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1316     if [[ -n ${libdir} ]] ; then
1317     cat <<-EOF
1318     if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1319     export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1320     else
1321     export LD_LIBRARY_PATH="${libdir}"
1322     fi
1323     EOF
1324     fi
1325 vapier 1.202 # We don't want to quote ${bin} so that people can pass complex
1326 vapier 1.414 # things as ${bin} ... "./someprog --args"
1327     printf 'exec %s "$@"\n' "${bin}"
1328     ) > "${tmpwrapper}"
1329 wolf31o2 1.160 chmod go+rx "${tmpwrapper}"
1330 vapier 1.414
1331 vapier 1.201 if [[ -n ${path} ]] ; then
1332 vapier 1.283 (
1333 vapier 1.201 exeinto "${path}"
1334 wolf31o2 1.164 newexe "${tmpwrapper}" "${wrapper}"
1335 vapier 1.283 ) || die
1336 wolf31o2 1.164 else
1337 vapier 1.283 newbin "${tmpwrapper}" "${wrapper}" || die
1338 wolf31o2 1.164 fi
1339 wolf31o2 1.160 }
1340 mr_bones_ 1.311
1341 vapier 1.351 # @FUNCTION: path_exists
1342     # @USAGE: [-a|-o] <paths>
1343     # @DESCRIPTION:
1344     # Check if the specified paths exist. Works for all types of paths
1345     # (files/dirs/etc...). The -a and -o flags control the requirements
1346     # of the paths. They correspond to "and" and "or" logic. So the -a
1347     # flag means all the paths must exist while the -o flag means at least
1348     # one of the paths must exist. The default behavior is "and". If no
1349     # paths are specified, then the return value is "false".
1350     path_exists() {
1351     local opt=$1
1352     [[ ${opt} == -[ao] ]] && shift || opt="-a"
1353    
1354     # no paths -> return false
1355     # same behavior as: [[ -e "" ]]
1356     [[ $# -eq 0 ]] && return 1
1357    
1358     local p r=0
1359     for p in "$@" ; do
1360     [[ -e ${p} ]]
1361     : $(( r += $? ))
1362     done
1363    
1364     case ${opt} in
1365     -a) return $(( r != 0 )) ;;
1366     -o) return $(( r == $# )) ;;
1367     esac
1368     }
1369 mgorny 1.364
1370     # @FUNCTION: in_iuse
1371     # @USAGE: <flag>
1372     # @DESCRIPTION:
1373     # Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1374     # as necessary.
1375     #
1376     # Note that this function should not be used in the global scope.
1377     in_iuse() {
1378     debug-print-function ${FUNCNAME} "${@}"
1379     [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1380    
1381     local flag=${1}
1382     local liuse=( ${IUSE} )
1383    
1384     has "${flag}" "${liuse[@]#[+-]}"
1385     }
1386 vapier 1.365
1387 vapier 1.367 # @FUNCTION: use_if_iuse
1388     # @USAGE: <flag>
1389     # @DESCRIPTION:
1390     # Return true if the given flag is in USE and IUSE.
1391     #
1392     # Note that this function should not be used in the global scope.
1393     use_if_iuse() {
1394     in_iuse $1 || return 1
1395     use $1
1396     }
1397    
1398 vapier 1.365 # @FUNCTION: usex
1399     # @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1400     # @DESCRIPTION:
1401 axs 1.404 # Proxy to declare usex for package managers or EAPIs that do not provide it
1402     # and use the package manager implementation when available (i.e. EAPI >= 5).
1403 vapier 1.365 # If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1404     # otherwise echo [false output][false suffix] (defaults to "no").
1405 ulm 1.405 if has "${EAPI:-0}" 0 1 2 3 4; then
1406 axs 1.404 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1407     fi
1408 vapier 1.371
1409 mgorny 1.395 # @FUNCTION: prune_libtool_files
1410 mgorny 1.408 # @USAGE: [--all|--modules]
1411 mgorny 1.395 # @DESCRIPTION:
1412     # Locate unnecessary libtool files (.la) and libtool static archives
1413     # (.a) and remove them from installation image.
1414     #
1415     # By default, .la files are removed whenever the static linkage can
1416     # either be performed using pkg-config or doesn't introduce additional
1417     # flags.
1418     #
1419 mgorny 1.408 # If '--modules' argument is passed, .la files for modules (plugins) are
1420     # removed as well. This is usually useful when the package installs
1421     # plugins and the plugin loader does not use .la files.
1422     #
1423     # If '--all' argument is passed, all .la files are removed without
1424     # performing any heuristic on them. You shouldn't ever use that,
1425     # and instead report a bug in the algorithm instead.
1426 mgorny 1.395 #
1427     # The .a files are only removed whenever corresponding .la files state
1428     # that they should not be linked to, i.e. whenever these files
1429     # correspond to plugins.
1430     #
1431 mgorny 1.411 # Note: if your package installs both static libraries and .pc files
1432     # which use variable substitution for -l flags, you need to add
1433     # pkg-config to your DEPEND.
1434 mgorny 1.395 prune_libtool_files() {
1435     debug-print-function ${FUNCNAME} "$@"
1436    
1437 mgorny 1.408 local removing_all removing_modules opt
1438 mgorny 1.395 for opt; do
1439     case "${opt}" in
1440     --all)
1441     removing_all=1
1442 mgorny 1.408 removing_modules=1
1443     ;;
1444     --modules)
1445     removing_modules=1
1446 mgorny 1.395 ;;
1447     *)
1448     die "Invalid argument to ${FUNCNAME}(): ${opt}"
1449     esac
1450     done
1451    
1452     local f
1453 mgorny 1.407 local queue=()
1454 mgorny 1.395 while IFS= read -r -d '' f; do # for all .la files
1455     local archivefile=${f/%.la/.a}
1456    
1457     [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1458    
1459 mgorny 1.408 local reason pkgconfig_scanned
1460    
1461 mgorny 1.395 # Remove static libs we're not supposed to link against.
1462     if grep -q '^shouldnotlink=yes$' "${f}"; then
1463 mgorny 1.400 if [[ -f ${archivefile} ]]; then
1464     einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1465 mgorny 1.407 queue+=( "${archivefile}" )
1466 mgorny 1.400 fi
1467 mgorny 1.395
1468     # The .la file may be used by a module loader, so avoid removing it
1469     # unless explicitly requested.
1470 mgorny 1.408 if [[ ${removing_modules} ]]; then
1471     reason='module'
1472     fi
1473 mgorny 1.395
1474     # Remove .la files when:
1475     # - user explicitly wants us to remove all .la files,
1476     # - respective static archive doesn't exist,
1477     # - they are covered by a .pc file already,
1478     # - they don't provide any new information (no libs & no flags).
1479 mgorny 1.408
1480     elif [[ ${removing_all} ]]; then
1481 mgorny 1.395 reason='requested'
1482     elif [[ ! -f ${archivefile} ]]; then
1483     reason='no static archive'
1484     elif [[ ! $(sed -nre \
1485     "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1486     "${f}") ]]; then
1487     reason='no libs & flags'
1488 mgorny 1.402 else
1489     if [[ ! ${pkgconfig_scanned} ]]; then
1490     # Create a list of all .pc-covered libs.
1491     local pc_libs=()
1492     if [[ ! ${removing_all} ]]; then
1493 mgorny 1.409 local pc
1494 mgorny 1.402 local tf=${T}/prune-lt-files.pc
1495     local pkgconf=$(tc-getPKG_CONFIG)
1496    
1497 mgorny 1.409 while IFS= read -r -d '' pc; do # for all .pc files
1498 mgorny 1.411 local arg libs
1499 mgorny 1.402
1500 mgorny 1.411 # Use pkg-config if available (and works),
1501     # fallback to sed.
1502     if ${pkgconf} --exists "${pc}" &>/dev/null; then
1503     sed -e '/^Requires:/d' "${pc}" > "${tf}"
1504     libs=$(${pkgconf} --libs "${tf}")
1505     else
1506     libs=$(sed -ne 's/^Libs://p' "${pc}")
1507     fi
1508    
1509     for arg in ${libs}; do
1510     if [[ ${arg} == -l* ]]; then
1511     if [[ ${arg} == '*$*' ]]; then
1512     eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1513     eqawarn "(arg: ${arg})"
1514     eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1515     fi
1516    
1517     pc_libs+=( lib${arg#-l}.la )
1518     fi
1519 mgorny 1.402 done
1520     done < <(find "${D}" -type f -name '*.pc' -print0)
1521    
1522     rm -f "${tf}"
1523     fi
1524    
1525     pkgconfig_scanned=1
1526     fi
1527    
1528     has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1529 mgorny 1.395 fi
1530    
1531     if [[ ${reason} ]]; then
1532     einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1533 mgorny 1.407 queue+=( "${f}" )
1534 mgorny 1.395 fi
1535 mgorny 1.407 done < <(find "${D}" -xtype f -name '*.la' -print0)
1536    
1537     if [[ ${queue[@]} ]]; then
1538     rm -f "${queue[@]}"
1539     fi
1540 mgorny 1.395 }
1541    
1542 vapier 1.372 check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1543    
1544 vapier 1.371 fi

  ViewVC Help
Powered by ViewVC 1.1.20